Subject: bug#47641: Ongoing difficulities after linphoneqt -> linphone-desktop transition

From: Maxim Cournoyer <[email-masked]>
Date: Wed, 01 Sep 2021 08:33:57 -0400

retitle 47641 linphone segfaults when receiving messages from a Linphone account
thanks

Hello,

Maxim Cournoyer <[email-masked]> writes:

> Hello Christopher,
>
> Christopher Howard <[email-masked]> writes:
>
>> I've kept RG on my list of contacts but have never received any
>> messages from him, and he doesn't seem to get mine.
>>
>> I still have my system frozen to use the older working version of
>> linphone, through the trick of using an inferior in my manifest
>> file. I have not recently tested anything newer than that.
>
> I've shared my private account privately with you, we can do some tests
> and see if there are any error messages appearing from the console, if
> you are available.

When I checked Linphone's output today, it had crashed, with the
following message:

--8<---------------cut here---------------start------------->8---
[...]

[18:34:28:135][Info]Core:linphone: channel [0x2a9a6f0] [334] bytes parsed
[18:34:28:135][Info]Core:linphone: Found transaction matching response.
[18:34:28:135][Info]Core:linphone: Changing [client] [MESSAGE] transaction [0x426f760], from state [TRYING] to [PROCEEDING]
[18:34:28:334][Info]Core:linphone: channel [0x2a9a6f0]: received [278] new bytes from [TLS://sip.linphone.org:5223]:
SIP/2.0 200 Ok
Via: SIP/2.0/TLS 192.168.10.15:59384;received=66.158.153.61;branch=z9hG4bK.2eNQCqmQS;rport=59384
From: <sip:[email-masked]>;tag=dZU47iIcu
To: <sip:[email-masked]>;tag=qAHFPPW
Call-ID: fAx3bYNPwa
CSeq: 20 MESSAGE
Content-Length: 0

[18:34:28:335][Info]Core:linphone: channel [0x2a9a6f0] [278] bytes parsed
[18:34:28:335][Info]Core:linphone: Found transaction matching response.
[18:34:28:335][Info]Core:linphone: Changing [client] [MESSAGE] transaction [0x426f760], from state [PROCEEDING] to [COMPLETED]
[18:34:28:337][Error]Core:linphone: Unhandled generic exception in MainDb::getEventFromKey: `std::bad_cast`.
[18:34:28:337][Error]Core:linphone: cannot find eventLog for db key [0x3a5bdb0] associated to message [0x3a5bd70]
[18:34:28:338][Error]Core:linphone: Unhandled generic exception in MainDb::getEventFromKey: `std::bad_cast`.
Segmentation fault
--8<---------------cut here---------------end--------------->8---

When attempting to restart Linphone, the crash persists, like so:

--8<---------------cut here---------------start------------->8---
[08:24:53:002][Info]Core:linphone: Changing [server] [NOTIFY] transaction [0x234a7f0], from state [INIT] to [TRYING]
[08:24:53:002][Info]Core:linphone: belle_sip_object_to_string(): temporary buffer is too short while doing to_string() for belle_sip_multipart_body_handler_t, retrying
[08:24:53:002][Error]Core:linphone: body handler [0x2feabc0] transfered only [2085] bytes while [4106] were expected
[08:24:53:002][Info]Core:linphone: Notify presence for list 0x13bce40
[08:24:53:006][Info]Core:linphone: QT: components/sip-addresses/SipAddressesModel.cpp:340: "Update presence of `sip:[email-masked]`: 1."
[08:24:53:006][Info]Core:linphone: Linphone core [0x1094240] notified [notify_presence_received_for_uri_or_tel]
[08:24:53:006][Info]Core:linphone: Linphone core [0x1094240] notified [notify_presence_received]
[08:24:53:006][Info]Core:linphone: Changing [server] [NOTIFY] transaction [0x234a7f0], from state [TRYING] to [COMPLETED]
[08:24:53:006][Info]Core:linphone: channel [0x1abbb70]: message sent to [TLS://sip.linphone.org:5223], size: [478] bytes
SIP/2.0 200 Ok
Via: SIP/2.0/TLS sip6.linphone.org:5223;received=54.37.202.229;rport;branch=z9hG4bK.0cj7De7HvSgcry9BNc0Z595SSc
Via: SIP/2.0/TCP 127.0.0.1:5065;branch=z9hG4bK.45hjmVnWu;rport=54254
From: <sips:[email-masked]>;tag=BUE0Wu8
To: <sip:[email-masked]>;tag=SrhwXqDiL
Call-ID: E4D8HWHxNd
CSeq: 111 NOTIFY
User-Agent: Linphone Desktop/4.2.5 (Linux 5.13.12-gnu, Qt 5.15.2) LinphoneCore/4.4.0
Supported: replaces, outbound, gruu
Content-Length: 0

[08:24:53:006][Info]Core:linphone: Dialog [0x2bf2fa0]: now updated by transaction [0x234a7f0].
[08:24:53:006][Info]Core:linphone: Garbage collecting unowned object of type belle_sip_header_content_type_t
[08:24:53:011][Info]Core:linphone: channel [0x1abbb70]: received [334] new bytes from [TLS://sip.linphone.org:5223]:
SIP/2.0 100 Trying
Via: SIP/2.0/TLS 192.168.10.15:59386;branch=z9hG4bK.68gzFFTF3;rport=59386;received=66.158.153.61
From: <sip:[email-masked]>;tag=oSC4-HTmj
To: <sip:[email-masked]>
Call-ID: pvi-2leZ~y
CSeq: 20 MESSAGE
Server: Flexisip/2.1.0-alpha-160-g988d5ffe (sofia-sip-nta/2.0)
Content-Length: 0

[08:24:53:013][Info]Core:linphone: channel [0x1abbb70] [334] bytes parsed
[08:24:53:013][Info]Core:linphone: Found transaction matching response.
[08:24:53:013][Info]Core:linphone: Changing [client] [MESSAGE] transaction [0x2beb760], from state [TRYING] to [PROCEEDING]
[08:24:53:013][Info]Core:linphone: Changing [server] [NOTIFY] transaction [0x234a7f0], from state [COMPLETED] to [TERMINATED]
[08:24:53:013][Info]Core:linphone: Server NOTIFY transaction [0x234a7f0] terminated
[08:24:53:013][Info]Core:linphone: Unhandled transaction terminated [0x234a7f0]
[08:24:53:032][Info]Core:linphone: channel [0x1abbb70]: received [334] new bytes from [TLS://sip.linphone.org:5223]:
SIP/2.0 100 Trying
Via: SIP/2.0/TLS 192.168.10.15:59386;branch=z9hG4bK.E49iyRRDc;rport=59386;received=66.158.153.61
From: <sip:[email-masked]>;tag=j~CfQFRgo
To: <sip:[email-masked]>
Call-ID: JvrRbU9Aqy
CSeq: 20 MESSAGE
Server: Flexisip/2.1.0-alpha-160-g988d5ffe (sofia-sip-nta/2.0)
Content-Length: 0

[08:24:53:033][Info]Core:linphone: channel [0x1abbb70] [334] bytes parsed
[08:24:53:033][Info]Core:linphone: Found transaction matching response.
[08:24:53:033][Info]Core:linphone: Changing [client] [MESSAGE] transaction [0x2cecf10], from state [TRYING] to [PROCEEDING]
[08:24:53:052][Info]Core:linphone: channel [0x1abbb70]: received [278] new bytes from [TLS://sip.linphone.org:5223]:
SIP/2.0 200 Ok
Via: SIP/2.0/TLS 192.168.10.15:59386;received=66.158.153.61;branch=z9hG4bK.68gzFFTF3;rport=59386
From: <sip:[email-masked]>;tag=oSC4-HTmj
To: <sip:[email-masked]>;tag=44ddfWh
Call-ID: pvi-2leZ~y
CSeq: 20 MESSAGE
Content-Length: 0

[08:24:53:053][Info]Core:linphone: channel [0x1abbb70] [278] bytes parsed
[08:24:53:053][Info]Core:linphone: Found transaction matching response.
[08:24:53:053][Info]Core:linphone: Changing [client] [MESSAGE] transaction [0x2beb760], from state [PROCEEDING] to [COMPLETED]
[08:24:53:054][Error]Core:linphone: Unhandled generic exception in MainDb::getEventFromKey: `std::bad_cast`.
[08:24:53:054][Error]Core:linphone: cannot find eventLog for db key [0x13be7d0] associated to message [0x13be790]
[08:24:53:054][Error]Core:linphone: Unhandled generic exception in MainDb::getEventFromKey: `std::bad_cast`.
--8<---------------cut here---------------end--------------->8---

It should make it not too difficult to reproduce it in GDB and gather a
backtrace.

Maxim